解题报告:HDU 5763

Problem Description
As is known to all, in many cases, a word has two meanings. Such as “hehe”, which not only means “hehe”, but also means “excuse me”. 
Today, ?? is chating with MeiZi online, MeiZi sends a sentence A to ??. ?? is so smart that he knows the word B in the sentence has two meanings. He wants to know how many kinds of meanings MeiZi can express.
 

Input
The first line of the input gives the number of test cases T; T test cases follow.
Each test case contains two strings A and B, A means the sentence MeiZi sends to ??, B means the word B which has two menaings. string only contains lowercase letters.

Limits
T <= 30
|A| <= 100000
|B| <= |A|

 

Output
For each test case, output one line containing “Case #x: y” (without quotes) , where x is the test case number (starting from 1) and y is the number of the different meaning of this sentence may be. Since this number may be quite large, you should output the answer modulo 1000000007.
 

Sample Input

4 hehehe hehe woquxizaolehehe woquxizaole hehehehe hehe owoadiuhzgneninougur iehiehieh
 

Sample Output

Case #1: 3 Case #2: 2 Case #3: 5 Case #4: 1
Hint
In the first case, “ hehehe” can have 3 meaings: “*he”, “he*”, “hehehe”. In the third case, “hehehehe” can have 5 meaings: “*hehe”, “he*he”, “hehe*”, “**”, “hehehehe”.



































































这道题很明显是用DP做,但是最主要的是DP的方式……
最开始的想法是dp[i]存放从0开始到i为止的种类数,然后分为本意和另外一个意思来分别讨论,结果发现这样做不出来……
后来看过题解才明白只要转换下思路就可以了,dp[i]应该表示位置i到末尾的种类数。
首先dp[i]=dp[i-1],即每个当前位置都是由前一个位置得出来的,这是增加的基础。
其次如果i-len2到i这段和b匹配上了,那如果他使用了另一个含义,则i-len2到i的都不能改变了,所以应该是加上i-len2时候的种类数。
所以dp[i]+=dp[i-len2]
代码其实很简单,如下
#include
#include
#include
#include
#include
#include
using namespace std;
string a,b;
long long dp[100010];
int mod=1e9+7;
int main()  
{  
    //freopen("in.txt","r",stdin);  
    //freopen("out.txt","w",stdout);  
    int t;  
    cin>>t;
    for(int Case=1;Case<=t;Case++)  
    {  
		memset(dp,-1,sizeof(dp));
		cin>>a>>b;
		dp[0]=1;
		for(int i=1;i<=a.length();i++){

			dp[i]=dp[i-1];
			if(i>=b.length()&&a.substr(i-b.length(),b.length())==b)
				dp[i]=(dp[i-b.length()]+dp[i])%mod;

		}
		printf("Case #%d: %d\n",Case,dp[a.length()]);
		
    }  
    return 0;  
}  
所以说学好DP还是很重要的……
























你可能感兴趣的:(解题报告:HDU 5763)